/*  case filter -- translate a file to upper, lower or mixed case 
		 
    Copyright (C) 1985,1990,2003  Norm London, London Computing

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	norm_london@londoncomputing.com

	Windows:     Compile with Visual Studio 5 or later or gcc 2.9.5 or later
	should work with just about any c compiler.
	cl case.c
	windows or unix using gcc:
	gcc case.c -o case.exe
*/

#define BLEN 58000
#include <stdio.h>
#include <ctype.h>
//#include <io.h>
//#include <fcntl.h>
// #include <malloc.h>
#include <string.h>
int main(int argc,char *argv[]) {
/* filter all text to upper case, lower case, mixed case  */
/* mixed case: any character preceded by a space is upper, else lower */
	char *b,buffer[BLEN],flag,prev;
	unsigned i,k,blen;
	static char signon[]="Textfile Case Filter V1.0 (C) London Computing, 1985, 1990, 2003\n";
	static char usage[]="Usage is: CASE {-U[pper] | -L[ower] | -M[ixed]\n";

	if (argc > 1 && argv[1][0] == '-')
		flag = toupper(argv[1][1]);
	else
		flag = -1;

	fprintf(stderr,signon);
	if (strchr("ULM",flag) == NULL) {
		fprintf(stderr,"CASE Filter V1.01, %s\n",__DATE__);
		fprintf(stderr,"Copyright 1985,1990, 2003, Norm London, London Computing.\nnorm_london@londoncomputing.com\n\n");
		fprintf(stderr,"This program is free software; you can redistribute it and/or modify\n");
		fprintf(stderr,"it under the terms of the GNU General Public License as published by\n");
		fprintf(stderr,"the Free Software Foundation; either version 2 of the License, or\n");
		fprintf(stderr,"(at your option) any later version.\n\n");
		fprintf(stderr,"This program is distributed in the hope that it will be useful,\n");
		fprintf(stderr,"but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
		fprintf(stderr,"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
		fprintf(stderr,"GNU General Public License for more details.\n\n");
		fprintf(stderr,"You should have received a copy of the GNU General Public License\n");
		fprintf(stderr,"along with this program; if not, write to the Free Software\n");
		fprintf(stderr,"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n\n");
		fprintf(stderr,usage);
		fprintf(stderr,"Read from standard input, write to standard output, redirection permitted.\n");
		fprintf(stderr,"-U -- Translate input to upper case.\n");
		fprintf(stderr,"-L -- translate input to lower case.\n");
		fprintf(stderr,"-M -- Translate to mixed case (capitalize first letter of each word.\n");
		return 4;
	}

	blen=BLEN;

	while (fgets(buffer,blen,stdin)!=NULL) {
		for (b=buffer;*b;++b) {
			switch(flag) {
			case 'U': 
				*b = toupper(*b); 
				break;
			case 'L': 
				*b = tolower(*b); 
				break;
			case 'M':
				*b = (prev == ' ') ? toupper(*b) : tolower(*b);
				prev = isspace(*b) ? ' ' : *b;
				break;
			}
		}
		fputs(buffer,stdout);
	}
	return(0);
}
